#encode: utf-8
require 'sketchup.rb'
require 'BGSketchup/BGSketchup.rb'

module BGSketchup_Composants
	$BGSketchup_Composants_Update_in_progress="non"
	$BGSketchup_Composants_Demarre="non"
	$BGSketchup_Composants_Selection_en_cours=false
	class Gestionnaire
		require 'BGSketchup/Composants/Rb/Localization.rb'
		def demarrer
			load_options
			initialise_localization
			$BGSketchup_Composants_Update_in_progress="non"
			@liste_definitions=[]
			initialize_window if @option_DemarrageAuto
		end
		
		def initialize_window
			$BGSketchup_Composants_Demarre="oui"
			@w = UI::WebDialog.new(@strWindowName+" "+BGSketchup_Composants_extension.version, false,"BGSketchup_Composants" , 316, 293, 100, 200, true)
			@wh=Sketchup.find_support_file "treeview.html" ,"Plugins/BGSketchup/Composants/Html"
			@w.set_file(@wh)
			@w.set_background_color("ffffff")
			@w.show()
			@w.min_height = 302
			@w.min_width = 326-10
			@w.set_size(326-20,302)
			@element_selectionne=nil
			@Timer_message_en_cours=false
			
			@w.add_action_callback("get_data") do |web_dialog,action_name| 				
				maj_liste(action_name) if (action_name=="charger" && @option_DemarrageAutoMAJListe)
				maj_liste(action_name) if (action_name=="maj")						#Mettre à jour la liste
				afficher_info(action_name[13..action_name.length-2]) if action_name[0..11]=="clickElement" #Si on clique sur un élément de la liste, on affiche les infos
				changer_lien if action_name=="changer_lien"							#On veut changer le lien
				enregistrer_definition if action_name=="enregistrer_definition"		#Enregistrer la définition
				recharger_definition if action_name=="recharger_definition"			#Recharger la définition
				enregistrer_definitions if action_name=="enregistrer_definitions"	#Enregistrer les définitions
				recharger_definitions if action_name=="recharger_definitions"		#Recharger les définitions
				selectionner_instances if action_name=="selectionner_instances"		#Sélectionner les instances
				UI.messagebox @strAPropos if action_name=="apropos"					#A propos
				options if action_name=="options"									#Options
				charger_titres if action_name=="charger_titres"
				editer_composant if action_name=="editer_composant"
				renommer_composant if action_name=="renommer_composant"
			end	
		end
		
		def editer_composant
			if @element_selectionne!=nil && @num_element!="?" then
				definition=@liste_definitions[@element_selectionne][0]
				nouveau_chemin=chemin_composant(definition)
				nouveau_chemin=bgSketchup_to_ascii(nouveau_chemin)
				nouveau_chemin=fichier_dernier_indice(nouveau_chemin,@option_TexteIndice) if @option_UtiliserIndice==true #check for new level
				if File.exist?(nouveau_chemin)!=false then 
					system('start sketchup "' + nouveau_chemin + '"') #Mettre start /wait sketchup pour attendre la fermeture de l'autre sketchup
				
					reponse=UI.messagebox @strEditerSketchup+10.chr+13.chr+@strEditerAnnulerEgalRelance,MB_YESNOCANCEL
					if reponse==6 then
						charge(definition,true,nil)
						maj_liste
					elsif reponse==2 then
						@id_rappel = UI.start_timer(@option_temps_rappel_maj, true) { rappellerMAJ(definition) }
					end
				else
					UI.messagebox @strMenuVerifierpresence
				end
			end
		end
		def rappellerMAJ(definition)
			if @Timer_message_en_cours==false then	#Si un message n'est pas déjà en cours
				if definition.deleted? ==false then
					@Timer_message_en_cours=true
					reponse=UI.messagebox "Voulez-vous mettre à jour le composant '" + definition.name + "' ?", MB_YESNOCANCEL
					@Timer_message_en_cours=false
					if reponse==6 then 		#oui = on met à jour
						UI.stop_timer @id_rappel
						charge(definition,true,nil)
						maj_liste
					elsif reponse==7 then 	#non = on arrête le timer
						UI.stop_timer @id_rappel
					else					#annuler = on ne fait rien
					end
				else
					UI.stop_timer @id_rappel # Definition supprimée, on arrête le timer
				end
			end
		end
		
		
		def renommer_composant
			if @element_selectionne!=nil && @num_element!="?" then
				definition=@liste_definitions[@element_selectionne][0]
				input=UI.inputbox [@strNouveauNom],[definition.name],@strRenommer
				if input!=nil then
					definition.name=input[0]
					if definition.name!=input[0] then
						UI.messagebox @strComposantRenommeEn + definition.name
					end
					maj_liste
				end
			end
		end
		#To update the list
		def maj_liste(action_name="maj")
			@liste_definitions=[]
			liste=""
			# On liste les composants du fichiers
			liste=liste_composants(liste,Sketchup.active_model,0,Sketchup.active_model,Sketchup.active_model,nil)
			if liste!="" then
				js_command =""
				js_command += "desactivateTree('LinkedList1');" if action_name=="maj" # On désactive les liens de la liste précédente
				js_command += "document.getElementById('LinkedList1').innerHTML='" << liste.to_s << "';"	# On ajoute la liste
				js_command += "addEvents('LinkedList1');"	# On initialise les liens de la liste
				@w.execute_script(js_command)
			end
			@element_selectionne==nil
			
			time=Time.new
			h=@strHeureMAJListe+time.strftime("%H:%M:%S")
			Sketchup.status_text = h
			barre_etat(h)
		end
		def liste_composants(liste,entity,nb_instances_branche, instance=nil, ent_parent=nil, instancesID=nil)	#Ajoute à "liste" la liste des sous composants de entity (récursif)
			#liste = 					la liste avant l'ajout
			#entity = 					entité à ajouter dans la liste
			#nb_instannces_branche = 	nombre d'instance de "entity" dans la branche
			#instance = 				instance de "entity" qui a déclenché l'ajout dans la liste
			#ent_parent =				entité du parent de "entity"
			#instancesID =				tableau avec les entityID des autres instances de "entity" dans le parent de "entity"
			
			entity_de_depart=instance
			modele=(entity.is_a? Sketchup::Model)
			if (entity.is_a? Sketchup::ComponentInstance) || (entity.is_a? Sketchup::ComponentDefinition) || (entity.is_a? Sketchup::Group) || (entity.is_a? Sketchup::Model) then
				entity=entity.definition if (entity.is_a? Sketchup::ComponentInstance)
				#On regarde les sous-composants (on met tout dans liste2)
				trouve=false; liste2=""; l=[]; i=0; model_length=Sketchup.active_model.entities.length
				
				######################## SCAN OF SUB ELEMENTS ########################
				for ent in entity.entities
					#Show progress
						if modele==true then
							Sketchup.status_text = @strAvancementMAJ + ((1000*(i.to_f/model_length)).round.to_f/10).to_s + "%"
							i+=1
						end

					#Check entities
					if (ent.is_a? Sketchup::ComponentInstance) || (ent.is_a? Sketchup::ComponentDefinition) || (ent.is_a? Sketchup::Group) then
						inst=nil;inst=ent #if (ent.is_a? Sketchup::ComponentInstance)
						ent=ent.definition if (ent.is_a? Sketchup::ComponentInstance)
						nom = ent.name if (ent.is_a? Sketchup::ComponentDefinition)
						nom = nil if (ent.is_a? Sketchup::Group)
						
						if l.index(nom)==nil then 			#Si on a pas déjà ajouté le sous-composant
							liste2+='<ul>' if trouve==false
							trouve=true
							if (ent.is_a? Sketchup::ComponentDefinition) then 	#ComponentDefinition
								#Count instances number in parent
								nb=0; id=[]
								for entite in entity.entities
									if (entite.is_a? Sketchup::ComponentInstance) then
										if entite.definition==inst.definition then
											nb+=1
											id.push entite.entityID #ont pour parent "entity"
										end
									end
								end								
								liste2=liste_composants(liste2,ent,nb,inst,entity_de_depart,id) #Récursif (le père de la sous liste c'est ent)
							else #Group
								liste2=liste_composants(liste2,ent,1,inst,entity_de_depart,[ent.entityID]) 	#Récursif
							end
							l.push nom if nom!=nil
						else
							#On l'a déjà ajouté
						end
					end
				end
				#On met dans les 
				
				######################## ADD ELEMENTS TO LIST ########################
				if (entity.is_a? Sketchup::Model) then		#Si l'entity était le MODEL
					if liste2!="" && liste2!="<ul>" then 	#Il y a qqchose en dessous
						#On supprime le <ul> en début de liste
						liste2=liste2[4..liste.length-1]
						liste+=liste2
						return liste
					else 									#Il n'y a rien en dessous
						return ""
					end
				end
				
				#On les ajoute à la liste
				if entity.is_a? Sketchup::Group then		#On a un GROUPE
					if liste2!="" && liste2!="<ul>" then 	#Il y a qqchose en dessous
						liste+='<li class="group_plus" data-test="?" id="'+@liste_definitions.length.to_s+'">(' + bgSketchup_to_java(entity.name) + ")" if entity.name!=""
						liste+='<li class="group_plus" data-test="?" id="'+@liste_definitions.length.to_s+'">(' + @strGroupSansNom + ')' if entity.name==""
						#On ajoute le group à la liste des définitions
						@liste_definitions.push ["?",ent_parent,instancesID]
						liste+=liste2
						liste+="</ul>" if liste2[0..3]=="<ul>" 
						liste+="</li>"
					else 									#Il n'y a rien en dessous
						liste2="" if liste2=="<ul>"
						if @option_afficher_groupes==true then	#On affiche quand même le groupe, si l'option est activée
							liste+='<li class="group" data-test="?" id="'+@liste_definitions.length.to_s+'">(' + bgSketchup_to_java(entity.name) + ")" if entity.name!=""
							liste+='<li class="group" data-test="?" id="'+@liste_definitions.length.to_s+'">(' + @strGroupSansNom + ')' if entity.name==""
							#On ajoute le group à la liste des définitions
							@liste_definitions.push ["?",ent_parent,instancesID]
							liste+=liste2
							liste+="</ul>" if liste2[0..3]=="<ul>" 
							liste+="</li>"
						end
					end
					
				else										#On a un COMPOSANT
					entity=entity.definition if (entity.is_a? Sketchup::ComponentInstance)
					
					#On regarde le chemin actuel (par défaut le chemin relatif)
					chemin_actuel =chemin_composant(entity)
					
					if chemin_actuel.to_s!="" then
						if @option_verifier_existance_fichier==true then #if @option_verifier_existance_fichier==true
							chemin_actuel=bgSketchup_to_ascii(chemin_actuel)
							if File.exist?(chemin_actuel)==true then
								date_fichier=date_to_str(File.mtime(chemin_actuel))
								date_entity =entity.get_attribute "BGSketchup_Composants", "Date"
								if date_fichier==date_entity then
									liste+='<li class="uptodate' 	#Chemin ok, date ok => VERT
								else
									if date_entity!=nil then
										if date_from_str(date_fichier)<date_from_str(date_entity) then
											liste+='<li title="' + @strDateFichierPlusAncien 	#Chemin ok, date nok => ROUGE
											if (@option_RecentRougeVif==true) then
												liste+='" class="older' # rouge foncé
											else
												liste+='" class="newer' # rouge vif
											end
										else
											liste+='<li title="' + @strDateFichierPlusRecent 	#Chemin ok, date nok => ROUGE
											if (@option_RecentRougeVif==true) then
												liste+='" class="newer' # rouge foncé
											else
												liste+='" class="older' # rouge vif
											end
										end
										
									else
										liste+='<li title="' + @strPasDateDefinition+ '" class="notuptodate' 			#Chemin ok, date ? => ROUGE
									end
								end
							else
								liste+='<li title="' + @strCheminFichierNOK+ '" class="no_link' 						#Chemin nok, date ? => ORANGE
							end
						else
							liste+='<li title="' + @strGrey+ '" class="grey' 											#Sans vérification => NOIR
						end
					else
						liste+='<li title="' + @strPasCheminDefintion+ '" class="unlinked'								#Sans lien vers un fichier => BLEU
					end
					#A chaque fois à la fin, on met :
					#La fin du nom de fichier
						if liste2!="" && liste2!="<ul>" then
							liste+= '_plus"'	# avec des sous-composants
						else
							liste+= '"'			# sans sous-composants
						end
					#On ajoute l'index dans la liste des définitions
						liste+= ' data-test="' 	+ @liste_definitions.length.to_s + '"'
						liste+= ' id="'			+ @liste_definitions.length.to_s + '" ' if (instance.is_a? Sketchup::ComponentInstance) #liste+= ' id="'+instance.to_s.gsub("#","")+'" ' if (instance.is_a? Sketchup::ComponentInstance) #element_liste_' + @liste_definitions.length.to_s 
						liste+= '>'
					#On met le nom de la definition dans le innerHTML
						liste+= bgSketchup_to_java(entity.name)
					#On ajout le nombre d'instance si on a coché l'option et qu'il y a plus d'une instance
						liste+= ' &#x21E8; ' + nb_instances_branche.to_s + "x" if nb_instances_branche!=1
					
					#On ajoute à la liste des définitions
						@liste_definitions.push [entity,ent_parent,instancesID] # if liste2=="<ul>"				#dans la liste générale


					#On ajoute la sous-liste
						liste2="" if liste2=="<ul>"###############
						liste+=liste2 
						liste+="</ul>" if liste2[0..3]=="<ul>"
					#On ferme la liste
						
				end
			end
			return liste
		end

		def afficher_info(num_element)
			#On retrouve la définition du composant
			if num_element!="?" then
				@element_selectionne=num_element.to_i
				definition=@liste_definitions[@element_selectionne][0]
				if definition!="?" then
					chemin=chemin_composant(definition)
					if @option_verifier_existance_fichier==true then
						if chemin!="" && chemin!=nil then #Si un chemin existe
							if File.exist?(chemin)==true then	#et si le fichier existe
								#On compare les dates
								date_fichier=date_to_str(File.mtime(chemin))
								date_definition=definition.get_attribute "BGSketchup_Composants", "Date"
								if date_definition !=nil then
									barre_etat(@strFichierAncien) if date_from_str(date_fichier)<date_from_str(date_definition)
									barre_etat(@strFichierRecent) if date_from_str(date_fichier)>date_from_str(date_definition)
									if date_from_str(date_fichier)==date_from_str(date_definition) then
										chemin = definition.get_attribute "BGSketchup_Composants", "Chemin"
										chemin = definition.path if chemin==nil
										barre_etat(chemin)
									end
								else
									barre_etat(@strPasDateDefinition)
								end
							else #Le fichier n'existe pas (lien cassé)
								#chemin = definition.get_attribute "BGSketchup_Composants", "Chemin"
								#chemin = definition.path if chemin==nil
								barre_etat(chemin)
							end
						else #On ne vérifie pas le chemin
							barre_etat(chemin)
						end
					else
						barre_etat(@strPasCheminDefintion)
					end
				else #c'est un groupe
				barre_etat(@strGroupe)
				@element_selectionne=nil					
				end
			else #c'est un groupe
				barre_etat(@strGroupe)
				@element_selectionne=nil
			end
			#On sélectionne les instances si l'option est cochée
			selectionner_instances if @option_SelectionAuto==true 
		end		
		def barre_etat(message)
			@w.execute_script("document.getElementById('zone_texte').value='" + bgSketchup_to_java(message.to_s) + "';")
		end
		
		#Buttons actions
		def changer_lien
			if @element_selectionne!=nil then						
				definition=@liste_definitions[@element_selectionne][0]
				#On regarde le chemin actuel (par défaut le chemin relatif)
				chemin_actuel =chemin_composant(definition)
				#On demande le nouveau lien
				nouveau_lien = UI.openpanel @strPanelOuvrir, "", chemin_actuel
				
				#Si tout es ok, on met à jour le dessin
				if nouveau_lien != nil then
					nouveau_lien=bgSketchup_to_ascii(nouveau_lien)
					if File.exists?(nouveau_lien)==true then
						nouveau_chemin = BGSketchup_creer_lien_relatif(nouveau_lien,bgSketchup_to_ascii(Sketchup.active_model.path))
						#On charge la nouvelle instance
							nom=definition.name
							nouvelle_definition = Sketchup.active_model.definitions.load nouveau_lien
						#On lui définit le lien relatif et la date
							$BGSketchup_Composants_Update_in_progress=true
							nouvelle_definition.set_attribute "BGSketchup_Composants", "Chemin", nouveau_chemin
							nouvelle_definition.set_attribute "BGSketchup_Composants", "Date", date_to_str(File.mtime(nouveau_lien))
						#On remplace toutes les anciennes instances par la nouvelles
							definition.instances.each { |instance|
								instance.definition=nouvelle_definition
							}
						#On purge les définitions pas utilisées
							Sketchup.active_model.definitions.purge_unused
							definition.name="tatayoyosurlechiouaoua" if definition.deleted? ==false
							nouvelle_definition.name=nom
							$BGSketchup_Composants_Update_in_progress=false
						#On enregistre la définition comme la nouvelle définition du composant
							@liste_definitions[@element_selectionne][0]=nouvelle_definition
						#On attache l'observer
							nouvelle_definition.entities.add_observer(MyEntitiesObserver.new)
						#On met à jour la page Html
							maj_liste
					else
						UI.messagebox @strCheminNOK
					end
				end
			end
		end
		def enregistrer_definition	#Enregistre la définition sélectionnée dans son fichier
			if @element_selectionne!=nil then						
				definition=@liste_definitions[@element_selectionne][0]
				
				#On regarde le chemin actuel (par défaut le chemin relatif)
				chemin=chemin_composant(definition)
				chemin=bgSketchup_to_ascii(chemin)
				if chemin==nil || chemin=="" then
					chemin = UI.savepanel @strPanelEnregistrer, Sketchup.active_model.path, "*.skp"
					return nil if chemin==nil
					chemin=bgSketchup_to_ascii(chemin)
					if File.exist?(chemin)==true then
						reponse = UI.messagebox @strRemplacerFichierExistant, MB_YESNO
						return nil if reponse!=6
					end
				else
					if File.exist?(chemin)==false then
						chemin = UI.savepanel @strPanelEnregistrer, Sketchup.active_model.path, "*.skp"
						return nil if chemin==nil
						chemin=bgSketchup_to_ascii(chemin)
						if File.exist?(chemin)==true then
							reponse = UI.messagebox @strRemplacerFichierExistant, MB_YESNO
							return nil if reponse!=6
						end
					end
				end
				#On enregistre
				if chemin!=nil
					if @option_UtiliserIndice then
						reponse=UI.messagebox @strEnregistrerNouvelIndice, MB_YESNO
						if reponse==6 then
							chemin=fichier_dernier_indice(chemin, @option_TexteIndice, true)
						end
					end
					resultat=definition.save_as chemin
					if resultat==false then
						UI.messagebox @strErreurEnregistrement+" (" + chemin_actuel + ")."
					else
						$BGSketchup_Composants_Update_in_progress="oui"
						definition.set_attribute "BGSketchup_Composants", "Chemin", BGSketchup_creer_lien_relatif(chemin,Sketchup.active_model.path)
						definition.set_attribute "BGSketchup_Composants", "Date", date_to_str(File.mtime(chemin))
						$BGSketchup_Composants_Update_in_progress="non"						
						UI.messagebox @strEnregistrementOK
						#On met à jour la liste
						maj_liste
					end
				end
			end
		end		
		def recharger_definition #Recharge depuis un fichier la définition
		
			# ATTENTION : est-ce que l'utilisateur veut un lien relatif ?????????????????????????????????
			
			return nil if @element_selectionne==nil
			definition=@liste_definitions[@element_selectionne][0]
			
			if definition!="?" then				#Si c'est pas un composant
				resultat=charge(definition, true, @element_selectionne)
				maj_liste if resultat!=nil 	#On met à jour la liste
			end
		end		
		def enregistrer_definitions
			return nil if (6!=(UI.messagebox @strEnregistrerDefinitions, MB_YESNO))
			passer_si_chemin_inexistant=((UI.messagebox @strPasserSiInexistant, MB_YESNO)==6)
			
			#On enregistre les définitions une par une
			compteur=0;compteur_ok=0
			@liste_definitions.each { |d|
				definition=d[0]
				if definition!="?" then # Pas d'enregistrement si c'est un groupe
					compteur+=1
					#On regarde le chemin actuel (par défaut le chemin relatif)
					chemin=chemin_composant(definition)
					chemin=bgSketchup_to_ascii(chemin)
					#On enregistre
					if chemin==nil then #Le chemin n'existe pas
						if !(passer_si_chemin_inexistant) then
							chemin = UI.savepanel definition.name.to_s+" : " +@strPanelEnregistrer, Sketchup.active_model.path, definition.name.to_s+".skp"
							if chemin!=nil then
								chemin=bgSketchup_to_ascii(chemin)
								if File.exist?(chemin)==true then
									reponse = UI.messagebox @strRemplacerFichierExistant, MB_YESNO
									chemin=nil if reponse!=6
								end
							end
						end
					end
					
					if chemin!=nil then
						if File.exists?(chemin) then
							if @option_UtiliserIndice then
								chemin=fichier_dernier_indice(chemin, @option_TexteIndice, true)
							end
							resultat=definition.save_as chemin
							if resultat==false then
								UI.messagebox @strErreurEnregistrementDefinition + definition.name.to_s + strErreurEnregistrementDefinition2 + chemin_actuel + ")."
							else
								compteur_ok+=1
								$BGSketchup_Composants_Update_in_progress="oui"
								definition.set_attribute "BGSketchup_Composants", "Chemin", BGSketchup_creer_lien_relatif(chemin,bgSketchup_to_ascii(Sketchup.active_model.path))
								definition.set_attribute "BGSketchup_Composants", "Date", date_to_str(File.mtime(chemin))
								$BGSketchup_Composants_Update_in_progress="non"
							end
							else
						end
					end
				else #c'est un groupe
				end
			}
			#On met à jour la liste
			maj_liste
			UI.messagebox @strNbEnregistementDefinitions+" ("+compteur_ok.to_s+"/"+compteur.to_s+")"
		end		
		def recharger_definitions
			@liste_definitions_rechargees=[]
			for ent in Sketchup.active_model.entities
				upload(ent)
			end
			#On met à jour la liste
			maj_liste
		end
		def upload (entity)	#Recharge (récursif) les composants de entity
			#On recharge si c'est une instance
			if (entity.is_a? Sketchup::ComponentInstance) then
				entity=entity.definition
				nom=entity.name
				entity=charge(entity) if @liste_definitions_rechargees.index(nom)==nil #On recharge uniquement si c'est pas déjà fait.
				@liste_definitions_rechargees.push nom
				return nil if entity.deleted? 
			end
			
			#On regarde en dessous de l'instance chargée (ou pas)
			if (entity.is_a? Sketchup::Group) || (entity.is_a? Sketchup::ComponentDefinition) then
				for ent in entity.entities
					if (ent.is_a? Sketchup::Group) || (ent.is_a? Sketchup::ComponentInstance) then #Un group ou un composant ?
						upload(ent) #On scanne en dessous => récursif
					end
				end
			end
		end
		def charge (definition, message=false, element=nil) #Recharge la définition et remplace les instances et ajoute les observers
			nouvelle_definition=definition
			#On regarde le chemin actuel (par défaut le chemin relatif)
			nouveau_chemin=chemin_composant(definition)
			nouveau_chemin=bgSketchup_to_ascii(nouveau_chemin)
			nouveau_chemin=fichier_dernier_indice(nouveau_chemin,@option_TexteIndice) if @option_UtiliserIndice==true #check for new level
			#On vérifie que le fichier atteignable
			if nouveau_chemin!=nil then
				if File.exist?(nouveau_chemin)!=false then 
					#Si le fichier est le même, alors pas de mise à jour nécessaire
						date_fichier=date_to_str(File.mtime(nouveau_chemin))
						date_definition =definition.get_attribute "BGSketchup_Composants", "Date"
						if date_fichier!=date_definition then #il y a une différence
							#On charge la nouvelle instance
								nom=definition.name
								nouvelle_definition = Sketchup.active_model.definitions.load nouveau_chemin
							#On lui définit le lien relatif
								chemin_relatif = BGSketchup_creer_lien_relatif(nouveau_chemin,bgSketchup_to_ascii(Sketchup.active_model.path))
								$BGSketchup_Composants_Update_in_progress="oui"
								nouvelle_definition.set_attribute "BGSketchup_Composants", "Chemin", chemin_relatif
								nouvelle_definition.set_attribute "BGSketchup_Composants", "Date", date_to_str(File.mtime(nouveau_chemin))
							#On remplace toutes les anciennes instances par la nouvelles
								definition.instances.each { |instance|
									instance.definition=nouvelle_definition
								}
							#On purge les définitions pas utilisées
								#Sketchup.active_model.definitions.purge_unused
								definition.name="tatayoyosurlechiouaoua" if definition.deleted? ==false
								nouvelle_definition.name=nom
								$BGSketchup_Composants_Update_in_progress="non"
							#On enregistre la définition comme la nouvelle définition du composant
								@liste_definitions[element][0]=nouvelle_definition if element!=nil
							#On attache l'observer
								nouvelle_definition.entities.add_observer(MyEntitiesObserver.new)
						else
							return definition #Le fichier correspondait à la définition : pas de mise à jour, on retourne la définition actuelle
						end
				else	# Si le fichier n'est pas atteignable, la nouvelle définition ne sera pas chargée
					UI.messagebox @strFichierPasAtteignable +10.chr+13.chr+nouveau_chemin.to_s if message==true
					return nil if element!=nil
				end
			else #Le chemin n'est pas défini
				UI.messagebox @strFichierPasAtteignable +10.chr+13.chr+nouveau_chemin.to_s if message==true
				return nil if element!=nil
			end
			return nouvelle_definition
		end

		#Selection
		def selectionner_instances
			return nil if @element_selectionne==nil
			$BGSketchup_Composants_Selection_en_cours=true
			definition=@liste_definitions[@element_selectionne][0]
			#return nil if definition=="?"
			model = Sketchup.active_model
			selection = model.selection
			selection.clear
			selection.add definition.instances
			$BGSketchup_Composants_Selection_en_cours=false
		end
		def choisir_element_liste(entity)	#retrouve un entity selectionné dans le modèle
			return nil if @option_SelectionAutoModel!=true || ($BGSketchup_Composants_Selection_en_cours) || entity==nil#|| !(entity.is_a? Sketchup::ComponentInstance)
			#On efface le fond
				js='efface_fond();'
			#On retrouve l'entity dans @liste_definitions
				i=retrouve_entite(entity)
				return nil if i==nil
				js+='showBranch("'+i.to_s+'");'
				
				
			#On déplie les branches au dessus
				parents=retrouve_id_parents(i) #On a un tableau avec les id
				if parents!=nil
					for p in parents
						js+='showBranch("'+p.to_s+'");'
					end
				end
				
			# On sélectionne l'instance			
				js+= 'document.getElementById("'+i.to_s+'").style.backgroundColor="#CCCCFF";'
				js+= 'found_element("'+i.to_s+'");'
			
			# On exécute le tout
				@w.execute_script(js) if @w!=nil
				
				afficher_info(i)
		end
		def retrouve_entite(entity)			#retrouve entity dans @liste_definitions
			return nil if (entity.is_a? Sketchup::Model) || entity==nil
			trouve=false
			for i in 0..@liste_definitions.length-1
				d=@liste_definitions[i]
				if d[2]!=nil && d[2]!=[]
					index=d[2].index(entity.entityID)
					if index!=nil then #On a la bonne definition
						item=i
						trouve=true
					end
				end
			end
			return nil if !trouve
			return item
		end		
		def retrouve_id_parents(i)			#retrouve les parents de l'item i dans @liste_definitions
			return nil if i==nil
			parents=[]
			i=retrouve_entite(@liste_definitions[i][1])
			while (i!=nil)
				oldi=i
				parents.push i
				i=retrouve_entite(@liste_definitions[i][1])
				if oldi==i then
					puts "erreur"
					return nil
				end
			end
			return parents
		end

		#Gestion des dates
		def date_from_str(str)
			return Time.local(str[0..3],str[4..5],str[6..7],str[9..10],str[11..12],str[13..14])
		end
		def date_to_str(date)
			return date.strftime("%Y%m%d %H%M%S")
		end
		
		#Options
		def options
			param0= (@option_verifier_existance_fichier==true) ? @strOui : @strNon
			param1= (@option_afficher_groupes==true) ? @strOui : @strNon
			param2= @option_langue ; param2old=param2
			param3= (@option_SelectionAuto==true) ? @strOui : @strNon
			param4= (@option_SelectionAutoModel==true) ? @strOui : @strNon
			param5= (@option_RecentRougeVif==true) ? @strOui : @strNon
			param6= (@option_UtiliserIndice==true) ? @strOui : @strNon
			param7= @option_TexteIndice
			param8= (@option_DemarrageAuto==true) ? @strOui : @strNon
			param9= (@option_DemarrageAutoMAJListe==true) ? @strOui : @strNon
			param10= @option_temps_rappel_maj
			
			strOuiNon=@strOui + "|" + @strNon
			input=UI.inputbox [@strOptionVerifierChemin,@strAfficherGroupe,@strLangue,@strSelectionAuto,@strSelectionAutoModele,@strOptionRecentRougeVif,@strOptionUtiliserIndice,@strOptionTexteIndice,@strDemarrageAuto,@strDemarrageAutoMAJListe,@strFrequenceRappelMAJ], \
				[param0,	param1,		param2,							param3,		param4,		param5,		param6,		param7,	param8,		param9,		param10], \
				[strOuiNon,	strOuiNon,	@availableLanguages.join("|"), 	strOuiNon,	strOuiNon,	strOuiNon,	strOuiNon,	"",		strOuiNon,	strOuiNon,	], \
				@strOptions
			if input!=false then
				@option_verifier_existance_fichier = (input[0]==@strOui)
				@option_afficher_groupes = (input[1]==@strOui)
				@option_langue=input[2]
				@option_SelectionAuto=(input[3]==@strOui)
				@option_SelectionAutoModel=(input[4]==@strOui)
				@option_RecentRougeVif=(input[5]==@strOui)
				@option_UtiliserIndice=(input[6]==@strOui)
				@option_TexteIndice=input[7]
				@option_DemarrageAuto=(input[8]==@strOui)
				@option_DemarrageAutoMAJListe=(input[9]==@strOui)
				@option_temps_rappel_maj=input[10].to_i
				save_options
				#On met à jour la page Html
				if @option_langue!=param2old then	#Si on change de langue, alors on redémarre l'interface
					@w.close
					BGSketchup_Composants::Mon_gestionnaire.demarrer
				else 						#Sinon, on met à jour la liste
					maj_liste
				end
			end
		end		
		def load_default_options	#Default options
			@option_verifier_existance_fichier=true
			@option_afficher_groupes= false 
			@option_langue=Sketchup.os_language
			@option_SelectionAuto=true
			@option_SelectionAutoModel=true
			@option_UtiliserIndice=false
			@option_TexteIndice=" ind"
			@option_RecentRougeVif=true
			@option_DemarrageAuto = false
			@option_DemarrageAutoMAJListe=true
			@option_temps_rappel_maj=60
		end

		def load_options
			#Load default option in case one option is missing
			load_default_options
			file_name=File.join(bgSketchup_getTempFolder,"BGSketchup_Composants.ini")
			if File.exists?(file_name)==true then 	#File exist
				file = File.open(file_name, "r")
				while !file.eof?
					option_name=file.readline.gsub(10.chr,"").gsub(13.chr,"")
					option_value=file.readline.gsub(10.chr,"").gsub(13.chr,"")
					@option_verifier_existance_fichier=(option_value=="true") ? true : false if option_name=="option_verifier_existance_fichier"
					@option_afficher_groupes=(option_value=="true") ? true : false if option_name=="option_afficher_groupes"
					@option_langue=option_value if option_name=="option_langue"
					@option_SelectionAuto=(option_value=="true") ? true : false if option_name=="option_SelectionAuto"
					@option_SelectionAutoModel=(option_value=="true") ? true : false if option_name=="option_SelectionAutoModel"
					@option_RecentRougeVif=(option_value=="true") ? true : false if option_name=="option_RecentRougeVif"
					@option_UtiliserIndice=(option_value=="true") ? true : false if option_name=="option_UtiliserIndice"
					@option_TexteIndice=option_value if option_name=="option_TexteIndice"
					@option_DemarrageAuto=(option_value=="true") ? true : false if option_name=="option_DemarrageAuto"
					@option_DemarrageAutoMAJListe=(option_value=="true") ? true : false if option_name=="option_DemarrageAutoMAJListe"
					@option_temps_rappel_maj=option_value.to_i if option_name=="option_temps_rappel_maj"
				end
				file.close
			else												#File doesn't exist
				#Save Default options
				save_options
			end
		end
		def save_options
			file_name=File.join(bgSketchup_getTempFolder,"BGSketchup_Composants.ini")
			File.delete(file_name) if File.exists?(file_name)
			file=File.new(file_name, "w")
			file.puts("option_verifier_existance_fichier") 
			file.puts(@option_verifier_existance_fichier)
			file.puts("option_afficher_groupes") 
			file.puts(@option_afficher_groupes)
			file.puts("option_langue") 
			file.puts(@option_langue)
			file.puts("option_SelectionAuto") 
			file.puts(@option_SelectionAuto)
			file.puts("option_RecentRougeVif") 
			file.puts(@option_RecentRougeVif)
			file.puts("option_UtiliserIndice") 
			file.puts(@option_UtiliserIndice)
			file.puts("option_TexteIndice") 
			file.puts(@option_TexteIndice)
			file.puts("option_DemarrageAuto") 
			file.puts(@option_DemarrageAuto)
			file.puts("option_DemarrageAutoMAJListe") 
			file.puts(@option_DemarrageAutoMAJListe)
			file.puts("option_temps_rappel_maj") 
			file.puts(@option_temps_rappel_maj)
			file.puts("option_SelectionAutoModel") 
			file.puts(@option_SelectionAutoModel)
			file.close
		end
			
		def charger_titres
			js=""
			for i in 0..@strButtonsTitles.length-1
				js+= "document.getElementById('Btn" + i.to_s + "').title='" + bgSketchup_to_java(@strButtonsTitles[i]) +"';"
				js+= "document.getElementById('CMT" + i.to_s + "').innerHTML='" + bgSketchup_to_java(@strContextMenuTitles[i]) +"';" if i<@strContextMenuTitles.length
			end
			@w.execute_script(js)
		end
		
		#Creation des menus
		def creations_menus
			menu=BGSketchup_Ajouter_Submenu("BGSketchup")
			menu.add_item(@strMenuGestionnaireComposants) {BGSketchup_Composants::Mon_gestionnaire.initialize_window }
		end
		def chemin_composant(entity)
			return nil if entity==nil #|| entity=="?"
			#On regarde le chemin actuel (par défaut le chemin relatif)
			return nil if (entity.attribute_dictionary "BGSketchup_Composants")==nil
			chemin_relatif = entity.get_attribute "BGSketchup_Composants", "Chemin"
			if chemin_relatif!=nil then
				return BGSketchup_retrouve_lien_absolu(chemin_relatif,Sketchup.active_model.path)
			else
				return entity.path
			end		
		end
		
		#Gestion des indices
		def fichier_dernier_indice(fichier, indice, indice_suivant=false)
			return nil if fichier==nil 
			#On retrouve le repertoire et le nom du fichier
				rep=File.dirname(fichier)
				nom=File.basename(fichier)
				ext=File.extname(fichier)
				base=File.basename(fichier, ".*" )
				
				if base.rindex(indice)!=nil then
					base=base[0..base.rindex(indice)-1]
				end
			#On liste les fichiers du répertoire ayant la même base de nom
				fichiers_ok=[]
				return fichier if File.directory?(rep)==false
				Dir.foreach(rep) { |f|
					b=File.basename(f)
					if (b[0..base.length+indice.length-1]==(base+indice)) then
						n_sans_ext=File.basename(b, ".*" )
						partie_apres_indice=b[(base+indice).length..n_sans_ext.length-1]
						partie_apres_indice=partie_apres_indice.strip! || partie_apres_indice	#On efface les espace en début et fin de chaine
						if partie_apres_indice.index(" ")!=nil then	#On prend le texte jusqu'au premier espace
							partie_apres_indice=partie_apres_indice[0..partie_apres_indice.index(" ")]
						end
						ind=b[(base+indice).length..n_sans_ext.length-1].to_i
						fichiers_ok.push [f,ind]
					end
				}
			#On retrouve le dernier indice
				if fichiers_ok!=[] then
					#On trouve l'indice le plus grand
					max=fichiers_ok[0][1]
					maxi=0
					for i in 0..fichiers_ok.length-1
						if (fichiers_ok[i][1]>max) then
							max=fichiers_ok[i][1]
							maxi=i
						end
					end
					#On retourne le fichier correspondant
					return File.join(rep,fichiers_ok[i][0]) if indice_suivant==false
					return File.join(rep,base+indice+(max+1).to_s+".skp") if indice_suivant==true
				else#On n'a pas de fichier avec indice, on l'ajoute
					return File.join(rep,base+indice+"1"+".skp")
				end
		end

		
	end
	
	#Add observers to Sketchup to detect when components changed
    class MyEntitiesObserver < Sketchup::EntitiesObserver
		def onElementAdded(entities, entity)
			parent=find_parent_component(entity)
			return nil if parent==nil && !(entity.is_a? Sketchup::ComponentInstance)			
			if ((entity.is_a? Sketchup::ComponentDefinition)  || (entity.is_a? Sketchup::ComponentInstance) || (entity.is_a? Sketchup::Group)) then
				entity=entity.definition if (entity.is_a? Sketchup::ComponentInstance)
				entity.entities.add_observer BGSketchup_Composants::MyEntitiesObserver.new
			else
				entity.add_observer BGSketchup_Composants::MyEntitiesObserver.new
			end
			if parent!=nil then
				parent.set_attribute "BGSketchup_Composants", "Date", Mon_gestionnaire.date_to_str(Time.now) if ($BGSketchup_Composants_Update_in_progress!="oui")
			end
		end
	    def onElementModified(entities, entity)
			return nil if entity.typename=="AttributeNamed" || entity.typename=="Thumbnail" || entity.typename=="AttributeContainer"
			parent=find_parent_component(entity)
			return nil if parent==nil
			parent.set_attribute "BGSketchup_Composants", "Date", Mon_gestionnaire.date_to_str(Time.now) if ($BGSketchup_Composants_Update_in_progress!="oui")
		end
		def onElementRemoved(entities, entity_id)
			return nil if entities.is_a? Sketchup::Model
			parent=find_parent_component(entities)
			return nil if parent==nil			
			parent.set_attribute "BGSketchup_Composants", "Date", Mon_gestionnaire.date_to_str(Time.now) if ($BGSketchup_Composants_Update_in_progress!="oui")
		end
		def onEraseEntities(entities)
			entities.parent.set_attribute "BGSketchup_Composants", "Date", Mon_gestionnaire.date_to_str(Time.now) if ((entities.parent.is_a? Sketchup::ComponentDefinition)  && ($BGSketchup_Composants_Update_in_progress!="oui"))
		end
		def find_parent_component(entity) #retrouve le composant parent de "entity", s'il existe (récursif)
			return nil if (entity.is_a? Sketchup::Model)
			return nil if (entity.parent.is_a? Sketchup::Model) && !(entity.is_a? Sketchup::ComponentInstance)
			return entity.parent.definition if (entity.parent.is_a? Sketchup::ComponentInstance) 
			return entity.parent if (entity.parent.is_a? Sketchup::ComponentDefinition)
			return find_parent_component(entity.parent)
		end
    end
	class MyAppObserver < Sketchup::AppObserver
		def onNewModel(model)
			# Attach the observer to all components
				for d in Sketchup.active_model.definitions; d.entities.add_observer(BGSketchup_Composants::MyEntitiesObserver.new); end
				Sketchup.active_model.entities.add_observer BGSketchup_Composants::MyEntitiesObserver.new
				
			# Attch observer to Sketchup and model
				Sketchup.add_observer(BGSketchup_Composants::MyAppObserver.new)
				Sketchup.active_model.add_observer(BGSketchup_Composants::MyModelObserver.new)
				Sketchup.active_model.selection.add_observer(BGSketchup_Composants::MySelectionObserver.new)
				
			# Update the list
				BGSketchup_Composants::Mon_gestionnaire.maj_liste if $BGSketchup_Composants_Demarre=="oui"
		end
		def onOpenModel(model)
			# Attach the observer to all components
				for d in Sketchup.active_model.definitions; d.entities.add_observer(BGSketchup_Composants::MyEntitiesObserver.new); end
				Sketchup.active_model.entities.add_observer BGSketchup_Composants::MyEntitiesObserver.new
				
			# Attch observer to Sketchup and model
				Sketchup.add_observer(BGSketchup_Composants::MyAppObserver.new)
				Sketchup.active_model.add_observer(BGSketchup_Composants::MyModelObserver.new)
				Sketchup.active_model.selection.add_observer(BGSketchup_Composants::MySelectionObserver.new)
				
			# Update the list
				BGSketchup_Composants::Mon_gestionnaire.maj_liste if $BGSketchup_Composants_Demarre=="oui"
		end
	end
	class MyModelObserver < Sketchup::ModelObserver
		def onAfterComponentSaveAs(model)
			#Component just save as, therefore the path have changed...
			#So we save also to related link
			definition=Sketchup.active_model.selection[0].definition
			chemin=definition.path
			if File.exists?(chemin) then
				$BGSketchup_Composants_Update_in_progress="oui"
				definition.set_attribute "BGSketchup_Composants", "Chemin", BGSketchup_creer_lien_relatif(chemin,Sketchup.active_model.path)
				definition.set_attribute "BGSketchup_Composants", "Date", Mon_gestionnaire.date_to_str(File.mtime(chemin))
				$BGSketchup_Composants_Update_in_progress="non"
			end
		end
	end
	class MySelectionObserver < Sketchup::SelectionObserver
		def onSelectionBulkChange(selection)
			entity= selection[0]
			BGSketchup_Composants::Mon_gestionnaire.choisir_element_liste(entity)
		end
	end
	Mon_gestionnaire=Gestionnaire.new
	
end #module

	 
if !file_loaded?(__FILE__) then
	#if File.exists?(File.join(BGSketchup::bgSketchup_getTempFolder,"Debug.bg")) then
	#	res = Sketchup.send_action "showRubyPanel:"
	#end
	
	# Start interface
		BGSketchup_Composants::Mon_gestionnaire.demarrer	
		BGSketchup_Composants::Mon_gestionnaire.creations_menus
	
    # Attach the observer to all components
		for d in Sketchup.active_model.definitions; d.entities.add_observer(BGSketchup_Composants::MyEntitiesObserver.new); end
		Sketchup.active_model.entities.add_observer BGSketchup_Composants::MyEntitiesObserver.new
		
	# Attch observer to Sketchup and model
		Sketchup.add_observer(BGSketchup_Composants::MyAppObserver.new)
		Sketchup.active_model.add_observer(BGSketchup_Composants::MyModelObserver.new)
		Sketchup.active_model.selection.add_observer(BGSketchup_Composants::MySelectionObserver.new)
	
end
file_loaded(__FILE__)